//+------------------------------------------------------------------+
//|                                                 !-TickStream.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern int  Bar       = 1000; 
extern bool ShowAsk   = true;
extern bool ShowMax   = true;
extern bool trade     = false;
//----
extern int  period1     = 12;
extern int  period2     = 24;
//---- buffers
double Bids[];
double Asks[];
string data[];
int hd,count=1;
string fn,varname;
int wind;
static bool start=true;
double ma1[2000],ma2[2000],ma3[2000],ma4[2000];
double max,min;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Bids);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Bid");
 if(ShowAsk){
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Asks);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Ask");
 }else{
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,Asks);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Ask"); 
 }  
   IndicatorShortName("iTickStreamXR");
//---------------------------
   varname=StringConcatenate(Symbol(),"trade");
   fn=StringConcatenate(Symbol(),"_",StringSubstr(TimeToStr(TimeCurrent(),TIME_DATE),0,10),"_xr.csv");
   start=true;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   //Filewrite();
//----
   return(0);
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Filewrite(){
     hd=FileOpen(fn,FILE_CSV|FILE_READ|FILE_WRITE);
     FileSeek(hd,0,SEEK_END);
     for(int i=count;i>0;i--){
       int err=FileWrite(hd,DoubleToStr(Bids[i],Digits),DoubleToStr(Asks[i],Digits));
       if(err<0){Print(GetLastError());break;}
     }   
     FileClose(hd);
     return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewDay(){
   static int PrevTime=0;
   if (PrevTime==iTime(Symbol(),1440,0)) return(false);
   PrevTime=iTime(Symbol(),1440,0);
   return(true);}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 
int start()
  { 
   static bool countc;static int bc;
   int spr=MarketInfo(Symbol(),MODE_SPREAD);
   int orders=GlobalVariableGet(Symbol()+"orders");
   wind=WindowFind("iTickStreamXR");
   if(start){ReadFile();start=false;}
   if(NewDay()){deinit();init();}
   for(int i=Bar;i>=0;i--){
     if(Bids[i]!=0.0){Bids[i+1]=Bids[i];}
     if(Asks[i]!=0.0){Asks[i+1]=Asks[i];}
   }
   Bids[0]=Close[0];   
   Asks[0]=Close[0]+spr*Point;
   //return;
   if(GlobalVariableCheck("sleep")){return;}
   if(!IsTesting()&&!IsVisualMode()&&!IsOptimization()){
     count++;
     if(count>=500){
       Filewrite();
       count=0;
     }
   }
   SetOrderLine();
   if(ObjectFind("Bars")>=0){
     if(orders<1){
      bc =iBarShift(Symbol(),0,ObjectGet("Bars",OBJPROP_TIME1))-1;
     }else{
      bc =iBarShift(Symbol(),0,ObjectGet("Bars",OBJPROP_TIME1))+1;
      if(countc){bc =iBarShift(Symbol(),0,ObjectGet("Bars",OBJPROP_TIME1))+1;countc=false;
      }else{bc =iBarShift(Symbol(),0,ObjectGet("Bars",OBJPROP_TIME1));countc=true;}
     }  
     if(bc>WindowFirstVisibleBar()){bc=WindowFirstVisibleBar()-WindowFirstVisibleBar()/10;}
     if(bc<=100){bc=100;}
     double prap=ObjectGet("Ap",OBJPROP_PRICE1);
     double prdn=ObjectGet("Dn",OBJPROP_PRICE1);
     double maxline=FindOrderLine(1);
     double minline=FindOrderLine(0);
     if(maxline!=0){
       if(prap<=maxline){bc=bc+(WindowBarsPerChart()/10);}
     }
     if(minline!=0){
       if(prdn>=minline){bc=bc+(WindowBarsPerChart()/10);}
     }
     ObjectSetText("Bars",DoubleToStr(bc,0),5,"Tahoma",White);   
     ObjectSet    ("Bars",OBJPROP_TIME1,Time[bc]);   
   }else{
     ObjectCreate ("Bars",OBJ_VLINE,wind,0,0,0,0,0,0);
     ObjectSet    ("Bars",OBJPROP_TIME1,Time[100]);
     ObjectSet    ("Bars",OBJPROP_COLOR,Silver);
     ObjectSet    ("Bars",OBJPROP_STYLE,1);  
   }
   double Pr[];
   ArrayResize(Pr,bc);
   for(i=0;i<=bc;i++){
     Pr[i]=NormalizeDouble(Bids[i],Digits);
   }
   max=Pr[ArrayMaximum(Pr)];
   min=Pr[ArrayMinimum(Pr)]+(Ask-Bid);
   int res=(max-min)/Point;
   
   int cp[];
   double prise[];
   ArrayResize(prise,res);
   ArrayResize(cp,res);
   for(int x=0;x<res;x++){
     int count=0;
     for(i=0;i<bc;i++){
       if(Pr[i]==NormalizeDouble(min+(x*Point),Digits)){count++;}
     }
     cp[x]=count;
     prise[x]=min+x*Point;
   }   
 if(ShowMax){
   double prline=prise[ArrayMaximum(cp)];
   if(ObjectFind("Pr")<0){
     ObjectCreate("Pr",OBJ_HLINE,wind,0,0,0,0,0,0);
     ObjectSet("Pr",OBJPROP_PRICE1,prline);
     ObjectSet("Pr",OBJPROP_COLOR,White);
     ObjectSet("Pr",OBJPROP_STYLE,2);
     ObjectSetText("Pr",DoubleToStr(cp[ArrayMaximum(cp)],0),5,"Tahoma",White);
   }else{
     ObjectSet("Pr",OBJPROP_PRICE1,prline);
     ObjectSetText("Pr",DoubleToStr(cp[ArrayMaximum(cp)],0),5,"Tahoma",White);
   }  
 }else{
   if(ObjectFind("Pr")==wind){
     ObjectDelete("Pr");
   }
 }
//----
       SetOrd3(max,min);
       //if(!SetOrd3(max,min)){
         SetOrd(max,min);
       //}   

//----   
   SetMaxMin(); 
   DelOrderLine();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
void SetMaxMin(){
   if(ObjectFind("Ap")<0){
     ObjectCreate("Ap",OBJ_HLINE,wind,0,0,0,0,0,0);
     ObjectSet("Ap",OBJPROP_PRICE1,max);
     ObjectSet("Ap",OBJPROP_COLOR,Red);
     ObjectSet("Ap",OBJPROP_STYLE,0);
     ObjectSet("Ap",OBJPROP_BACK,true);
     ObjectSetText("Ap","SELL Line",5,"Tahoma",White);
   }else{
     ObjectSet("Ap",OBJPROP_PRICE1,max);
     ObjectSet("Ap",OBJPROP_BACK,true);
     ObjectSetText("Ap","SELL Line",5,"Tahoma",White);
   }   
   if(ObjectFind("Dn")<0){
     ObjectCreate("Dn",OBJ_HLINE,wind,0,0,0,0,0,0);
     ObjectSet("Dn",OBJPROP_PRICE1,min);
     ObjectSet("Dn",OBJPROP_COLOR,Blue);
     ObjectSet("Dn",OBJPROP_STYLE,0);
     ObjectSet("Dn",OBJPROP_BACK,true);
     ObjectSetText("Dn","BUY Line",5,"Tahoma",White);
   }else{
     ObjectSet("Dn",OBJPROP_PRICE1,min);
     ObjectSet("Dn",OBJPROP_BACK,true);
     ObjectSetText("Dn","BUY Line",5,"Tahoma",White);
   }
return;
} 
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
bool SetOrd3(double max,double min){
  if(Bids[2]>=min&&Bids[1]>=min&&Bids[0]<min){
    GlobalVariableSet(varname, 1);
    Print("");
    return(true);  
  }
  if(Asks[2]<=max&&Asks[1]<=max&&Asks[0]>max){
    GlobalVariableSet(varname,-1);
    Print("");
    return(true);  
  }
  //GlobalVariableSet(varname,0);
  return(false);  
}
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void CloseOrd(double max,double min){
  if(Bids[2]<max&&Bids[1]==max&&Bids[0]<max){
    GlobalVariableSet("close", 1);
    return;  
  }
  if(Asks[2]>min&&Asks[1]==min&&Asks[0]<min){
    GlobalVariableSet("close", 1);
    return;  
  }
  //GlobalVariableDel("close");
  return;  
} 
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void SetOrd(double max,double min){int i;
//---- 
  if(Bids[0]>min){
    if(Bids[1]<=min){
      if(Bids[2]<min){
        if(Bids[3]>Bids[2]){
          Print("");
          GlobalVariableSet(varname,-1);
          return;
        }  
      }
    }
  }
//----
  if(Asks[0]<max){
    if(Asks[1]>=max){
      if(Asks[2]>max){
        if(Asks[3]<Asks[2]){
          Print("");
          GlobalVariableSet(varname, 1);
          return;
        }  
      }
    }
  }
//----
  //GlobalVariableSet(varname,0);
  return;  
}  
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void SetOrd2(double max,double min){
  if(Bids[2]<min&&Bids[1]<=min&&Bids[0]>min){
    GlobalVariableSet(varname,-1);
    Print("");
    return;  
  }
  if(Asks[2]>max&&Asks[1]>=max&&Asks[0]<max){
    GlobalVariableSet(varname, 1);
    Print("");
    return;  
  }
  //GlobalVariableSet(varname,0);
  return;  
}   
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
double FindOrderLine(int typ){double max=1000000,min=0;
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderType()<2){
          if(typ==0){
            if(OrderOpenPrice()<max){
              max=OrderOpenPrice();
            }
          }
          if(typ==1){
            if(OrderOpenPrice()>min){
              min=OrderOpenPrice();
            }          
          }          
        }
      }
    }
  }
  if(typ==0){
    if(max!=1000000){return(max);}else{return(0);}
  }
  if(typ==1){
    if(min!=0){return(min);}else{return(0);}
  }  
  return(0);
  }
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void DelOrderLine(){
  for(int i=0;i<OrdersHistoryTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
      if(OrderSymbol()==Symbol()){
        if(OrderType()<2){
          string name=DoubleToStr(OrderTicket(),0);
          if(ObjectFind(name)>0){
            ObjectDelete(name);
          }  
        }
      }
    }
  }return;
}
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void SetOrderLine(){
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderType()<2){
          SetHLine(OrderTicket(),OrderOpenPrice(),OrderType(),OrderProfit());
        }
      }
    }
  }return;
}
//+------------------------------------------------------------------+
void SetHLine(string name,double prise,int typ,double profit){
if(typ==0){color col=Blue;string type="BUY";}else{col=Red;type="SELL";}
  if(ObjectFind(name)<0){
    ObjectCreate(name,OBJ_HLINE,wind,0,0,0,0,0,0);
    ObjectSet(name,OBJPROP_PRICE1,prise);
    ObjectSet(name,OBJPROP_COLOR,col);
    ObjectSet(name,OBJPROP_STYLE,3);
    ObjectSetText(name,StringConcatenate(type,"  ",name,"  Profit =",profit),5,"Tahoma",col);
  }else{
    ObjectSetText(name,StringConcatenate(type,"  ",name,"  Profit =",profit),5,"Tahoma",col);
  }  
}
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+ 
void ReadFile(){int i,x,y;
   double spr=MarketInfo(Symbol(),MODE_SPREAD)*Point;  
   hd=FileOpen(fn,FILE_CSV|FILE_READ); 
   if(hd<0){
     Print(GetLastError(),"  ",fn,"  File not found",hd);   
     return;
   }else{
     FileReadString(hd);
     int pos=FileTell(hd);
     int size=FileSize(hd)/pos;
     //ArrayResize(Asks,size);
     //ArrayResize(Bids,size);
     ArrayResize(data,size*2);
     FileSeek(hd,0,SEEK_SET);
     for(x=0;x<size*2;x++){data[x]=FileReadString(hd);}
     if(ArrayGetAsSeries(data)){
       ArraySetAsSeries(data,false);
     }else{
       ArraySetAsSeries(data,true);
     }
     for(x=0;x<size;x++){
       if(StrToDouble(data[y])!=0.0)Asks[x]=StrToDouble(data[y]);
       y++;       
       if(StrToDouble(data[y])!=0.0)Bids[x]=StrToDouble(data[y]);
       y++;
     }
     FileClose(hd);
     if(Bar<size){Bar=size;}
   } 
return;
}